Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/Pcg.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/Pcg.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/Pcg.cs	(revision 16892)
@@ -0,0 +1,420 @@
+﻿// MIT License
+// 
+// Copyright (c) 2016 Bismur Studios Ltd.
+// Copyright (c) 2016 Ioannis Giagkiozis
+//
+// This file is part of PCGSharp.
+//
+// Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
+// and associated documentation files (the "Software"), to deal in the Software without restriction, 
+// including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
+// and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
+// subject to the following conditions:
+//
+//  The above copyright notice and this permission notice shall be included in all copies or substantial 
+//  portions of the Software.
+//
+//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT 
+//  LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN 
+//  NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
+//  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
+//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+// This file is based on PCG, the original has the following license: 
+/*
+ * PCG Random Number Generation for C.
+ *
+ * Copyright 2014 Melissa O'Neill <oneill@pcg-random.org>
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ *
+ * For additional information about the PCG random number generation scheme,
+ * including its license and other licensing options, visit
+ *
+ *       http://www.pcg-random.org
+ */
+
+using System;
+
+// Note, you will see that API is duplicated in PCG and PCGExtended, this is not by accident or 
+// neglect. It would be "cleaner" to have a base class and just implement the core of the generator
+// in derived classes, however, this has a performance cost which for random number generators, in my
+// view, is too high. That said, there is still some room for performance optimisation.
+
+namespace SimSharp {
+
+  /// <summary>
+  /// PCG (Permuted Congruential Generator) is a C# port from C the base PCG generator
+  /// presented in "PCG: A Family of Simple Fast Space-Efficient Statistically Good
+  /// Algorithms for Random Number Generation" by Melissa E. O'Neill. The code follows closely the one 
+  /// made available by O'Neill at her site: http://www.pcg-random.org/download.html
+  /// To understand how exactly this generator works read this:
+  /// http://www.pcg-random.org/pdf/toms-oneill-pcg-family-v1.02.pdf 
+  /// </summary>
+  internal class Pcg {
+
+    ulong _state;
+    // This shifted to the left and or'ed with 1ul results in the default increment.
+    const ulong ShiftedIncrement = 721347520444481703ul;
+    ulong _increment = 1442695040888963407ul;
+    const ulong Multiplier = 6364136223846793005ul;
+    const double ToDouble01 = 1.0 / 4294967296.0;
+    
+    public int Next() {
+      uint result = NextUInt();
+      return (int)(result >> 1);
+    }
+
+    public int Next(int maxExclusive) {
+      if (maxExclusive <= 0)
+        throw new ArgumentException("Max Exclusive must be positive");
+
+      uint uMaxExclusive = (uint)(maxExclusive);
+      uint threshold = (uint)(-uMaxExclusive) % uMaxExclusive;
+
+      while (true) {
+        uint result = NextUInt();
+        if (result >= threshold)
+          return (int)(result % uMaxExclusive);
+      }
+    }
+
+    public int Next(int minInclusive, int maxExclusive) {
+      if (maxExclusive <= minInclusive)
+        throw new ArgumentException("MaxExclusive must be larger than MinInclusive");
+
+      uint uMaxExclusive = unchecked((uint)(maxExclusive - minInclusive));
+      uint threshold = (uint)(-uMaxExclusive) % uMaxExclusive;
+
+      while (true) {
+        uint result = NextUInt();
+        if (result >= threshold)
+          return (int)(unchecked((result % uMaxExclusive) + minInclusive));
+      }
+    }
+
+    public int[] NextInts(int count) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new int[count];
+      for (var i = 0; i < count; i++) {
+        resultA[i] = Next();
+      }
+      return resultA;
+    }
+
+    public int[] NextInts(int count, int maxExclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new int[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = Next(maxExclusive);
+      }
+      return resultA;
+    }
+
+    public int[] NextInts(int count, int minInclusive, int maxExclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new int[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = Next(minInclusive, maxExclusive);
+      }
+      return resultA;
+    }
+
+    public uint NextUInt() {
+      ulong oldState = _state;
+      _state = unchecked(oldState * Multiplier + _increment);
+      uint xorShifted = (uint)(((oldState >> 18) ^ oldState) >> 27);
+      int rot = (int)(oldState >> 59);
+      uint result = (xorShifted >> rot) | (xorShifted << ((-rot) & 31));
+      return result;
+    }
+
+    public uint NextUInt(uint maxExclusive) {
+      uint threshold = (uint)(-maxExclusive) % maxExclusive;
+
+      while (true) {
+        uint result = NextUInt();
+        if (result >= threshold)
+          return result % maxExclusive;
+      }
+    }
+
+    public uint NextUInt(uint minInclusive, uint maxExclusive) {
+      if (maxExclusive <= minInclusive)
+        throw new ArgumentException();
+
+      uint diff = (maxExclusive - minInclusive);
+      uint threshold = (uint)(-diff) % diff;
+
+      while (true) {
+        uint result = NextUInt();
+        if (result >= threshold)
+          return (result % diff) + minInclusive;
+      }
+    }
+
+    public uint[] NextUInts(int count) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new uint[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextUInt();
+      }
+      return resultA;
+    }
+
+    public uint[] NextUInts(int count, uint maxExclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new uint[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextUInt(maxExclusive);
+      }
+      return resultA;
+    }
+
+    public uint[] NextUInts(int count, uint minInclusive, uint maxExclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new uint[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextUInt(minInclusive, maxExclusive);
+      }
+      return resultA;
+    }
+
+    public float NextFloat() {
+      return (float)(NextUInt() * ToDouble01);
+    }
+
+    public float NextFloat(float maxInclusive) {
+      if (maxInclusive <= 0)
+        throw new ArgumentException("MaxInclusive must be larger than 0");
+
+      return (float)(NextUInt() * ToDouble01) * maxInclusive;
+    }
+
+    public float NextFloat(float minInclusive, float maxInclusive) {
+      if (maxInclusive < minInclusive)
+        throw new ArgumentException("Max must be larger than min");
+
+      return (float)(NextUInt() * ToDouble01) * (maxInclusive - minInclusive) + minInclusive;
+    }
+
+    public float[] NextFloats(int count) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new float[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextFloat();
+      }
+      return resultA;
+    }
+
+    public float[] NextFloats(int count, float maxInclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new float[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextFloat(maxInclusive);
+      }
+      return resultA;
+    }
+
+    public float[] NextFloats(int count, float minInclusive, float maxInclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new float[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextFloat(minInclusive, maxInclusive);
+      }
+      return resultA;
+    }
+
+    public double NextDouble() {
+      return NextUInt() * ToDouble01;
+    }
+
+    public double NextDouble(double maxInclusive) {
+      if (maxInclusive <= 0)
+        throw new ArgumentException("Max must be larger than 0");
+
+      return NextUInt() * ToDouble01 * maxInclusive;
+    }
+
+    public double NextDouble(double minInclusive, double maxInclusive) {
+      if (maxInclusive < minInclusive)
+        throw new ArgumentException("Max must be larger than min");
+
+      return NextUInt() * ToDouble01 * (maxInclusive - minInclusive) + minInclusive;
+    }
+
+    public double[] NextDoubles(int count) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new double[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextDouble();
+      }
+      return resultA;
+    }
+
+    public double[] NextDoubles(int count, double maxInclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new double[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextDouble(maxInclusive);
+      }
+      return resultA;
+    }
+
+    public double[] NextDoubles(int count, double minInclusive, double maxInclusive) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new double[count];
+      for (int i = 0; i < count; i++) {
+        resultA[i] = NextDouble(minInclusive, maxInclusive);
+      }
+      return resultA;
+    }
+
+    public byte NextByte() {
+      var result = NextUInt();
+      return (byte)(result % 256);
+    }
+
+    public byte[] NextBytes(int count) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new byte[count];
+      for (var i = 0; i < count; i++) {
+        resultA[i] = NextByte();
+      }
+      return resultA;
+    }
+
+    public bool NextBool() {
+      var result = NextUInt();
+      return result % 2 == 1;
+    }
+
+    public bool[] NextBools(int count) {
+      if (count <= 0)
+        throw new ArgumentException("Zero count");
+
+      var resultA = new bool[count];
+      for (var i = 0; i < count; i++) {
+        resultA[i] = NextBool();
+      }
+      return resultA;
+    }
+
+    public int PeriodPow2() {
+      return 64;
+    }
+
+    public void SetStream(int sequence) {
+      SetStream((ulong)sequence);
+    }
+
+    public void SetStream(ulong sequence) {
+      _increment = (sequence << 1) | 1;
+    }
+
+    public ulong CurrentStream() {
+      return _increment >> 1;
+    }
+
+    public Pcg() : this(PcgSeed.GuidBasedSeed()) {
+    }
+
+    public Pcg(int seed) : this((ulong)seed) {
+    }
+
+    public Pcg(int seed, int sequence) : this((ulong)seed, (ulong)sequence) {
+    }
+
+    public Pcg(ulong seed, ulong sequence = ShiftedIncrement) {
+      Initialize(seed, sequence);
+    }
+
+    void Initialize(ulong seed, ulong initseq) {
+      _state = 0ul;
+      SetStream(initseq);
+      NextUInt();
+      _state += seed;
+      NextUInt();
+    }
+
+  }
+
+// MIT License
+// 
+// Copyright (c) 2016 Bismur Studios Ltd.
+// Copyright (c) 2016 Ioannis Giagkiozis
+//
+// This file is part of PCGSharp.
+//
+// Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
+// and associated documentation files (the "Software"), to deal in the Software without restriction, 
+// including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
+// and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
+// subject to the following conditions:
+//
+//  The above copyright notice and this permission notice shall be included in all copies or substantial 
+//  portions of the Software.
+//
+//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT 
+//  LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN 
+//  NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
+//  WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
+//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+//
+
+  internal static class PcgSeed {
+
+    /// <summary>
+    /// Provides a time-dependent seed value, matching the default behavior of System.Random.
+    /// </summary>
+    public static ulong TimeBasedSeed() {
+      return (ulong)(System.Environment.TickCount);
+    }
+
+    /// <summary>
+    /// Provides a seed based on time and unique GUIDs.
+    /// </summary>
+    public static ulong GuidBasedSeed() {
+      ulong upper = (ulong)(System.Environment.TickCount ^ Guid.NewGuid().GetHashCode()) << 32;
+      ulong lower = (ulong)(System.Environment.TickCount ^ Guid.NewGuid().GetHashCode());
+      return (upper | lower);
+    }
+
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/PcgRandom.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/PcgRandom.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/PcgRandom.cs	(revision 16892)
@@ -0,0 +1,50 @@
+﻿#region License Information
+/* SimSharp - A .NET port of SimPy, discrete event simulation framework
+Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
+#endregion
+
+namespace SimSharp {
+  public class PcgRandom : IRandom {
+    private Pcg pcg;
+
+    public PcgRandom() {
+      pcg = new Pcg();
+    }
+
+    public PcgRandom(int seed) {
+      pcg = new Pcg(seed);
+    }
+    public int Next() {
+      return pcg.Next();
+    }
+
+    public int Next(int upperBound) {
+      return pcg.Next(upperBound);
+    }
+
+    public int Next(int lowerBound, int upperBound) {
+      return pcg.Next(lowerBound, upperBound);
+    }
+
+    public double NextDouble() {
+      return pcg.NextDouble();
+    }
+
+    public void Reinitialise(int seed) {
+      pcg = new Pcg(seed);
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/SystemRandom.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/SystemRandom.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/Random/SystemRandom.cs	(revision 16892)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* SimSharp - A .NET port of SimPy, discrete event simulation framework
+Copyright (C) 2019  Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
+#endregion
+
+using System;
+
+namespace SimSharp {
+  public class SystemRandom : IRandom {
+    private Random random;
+
+    public SystemRandom() {
+      random = new Random();
+    }
+
+    public SystemRandom(int seed) {
+      random = new Random(seed);
+    }
+    public int Next() {
+      return random.Next();
+    }
+
+    public int Next(int upperBound) {
+      return random.Next(upperBound);
+    }
+
+    public int Next(int lowerBound, int upperBound) {
+      return random.Next(lowerBound, upperBound);
+    }
+
+    public double NextDouble() {
+      return random.NextDouble();
+    }
+
+    public void Reinitialise(int seed) {
+      random = new Random(seed);
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/SimSharp-3.1.1.csproj
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/SimSharp-3.1.1.csproj	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.ExtLibs/HeuristicLab.SimSharp/3.1.1/SimSharp-3.1.1/SimSharp-3.1.1.csproj	(revision 16892)
@@ -0,0 +1,139 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="12.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{9FE9C740-7859-4D01-AD07-7D4E15A6320B}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>SimSharp</RootNamespace>
+    <AssemblyName>SimSharp-3.1.1</AssemblyName>
+    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|AnyCPU'">
+    <OutputPath>..\..\..\..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <DocumentationFile>
+    </DocumentationFile>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\..\..\..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>..\..\..\..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <DocumentationFile>
+    </DocumentationFile>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>..\..\..\..\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>..\..\..\..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <DocumentationFile>
+    </DocumentationFile>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Analysis\ContinuousStatistics.cs" />
+    <Compile Include="Collections\EventQueue.cs" />
+    <Compile Include="Collections\EventQueueNode.cs" />
+    <Compile Include="Collections\Extensions.cs" />
+    <Compile Include="Collections\GenericPriorityQueue.cs" />
+    <Compile Include="Collections\GenericPriorityQueueNode.cs" />
+    <Compile Include="Collections\ReverseComparer.cs" />
+    <Compile Include="Collections\SimplePriorityQueue.cs" />
+    <Compile Include="Core\ActiveObject.cs" />
+    <Compile Include="Core\Events\AnyOf.cs" />
+    <Compile Include="Core\Events\AllOf.cs" />
+    <Compile Include="Core\Resources\Container.cs" />
+    <Compile Include="Core\Environment.cs" />
+    <Compile Include="Core\Resources\Events\ResourcePoolRequest.cs" />
+    <Compile Include="Core\Resources\Events\FilterStoreGet.cs" />
+    <Compile Include="Core\Resources\Events\StorePut.cs" />
+    <Compile Include="Core\Resources\Events\StoreGet.cs" />
+    <Compile Include="Core\Resources\Events\ContainerGet.cs" />
+    <Compile Include="Core\Resources\Events\ContainerPut.cs" />
+    <Compile Include="Core\Events\Condition.cs" />
+    <Compile Include="Core\Events\Event.cs" />
+    <Compile Include="Core\Resources\Events\PreemptiveRequest.cs" />
+    <Compile Include="Core\Events\Process.cs" />
+    <Compile Include="Core\Resources\Events\Release.cs" />
+    <Compile Include="Core\Resources\Events\Request.cs" />
+    <Compile Include="Core\Events\Timeout.cs" />
+    <Compile Include="Core\Exceptions\EmptyScheduleException.cs" />
+    <Compile Include="Core\Preempted.cs" />
+    <Compile Include="Core\Resources\FilterStore.cs" />
+    <Compile Include="Core\Resources\PreemptiveResource.cs" />
+    <Compile Include="Core\Resources\PriorityResource.cs" />
+    <Compile Include="Core\Resources\PriorityStore.cs" />
+    <Compile Include="Core\Resources\Resource.cs" />
+    <Compile Include="Core\Resources\ResourcePool.cs" />
+    <Compile Include="Core\Resources\Store.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Random\IRandom.cs" />
+    <Compile Include="Random\Pcg.cs" />
+    <Compile Include="Random\PcgRandom.cs" />
+    <Compile Include="Random\SystemRandom.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <Content Include="Collections\EventQueue-License.txt" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.cs	(revision 16892)
@@ -24,4 +24,5 @@
 using System.ComponentModel;
 using System.Drawing;
+using System.Globalization;
 using System.Linq;
 using System.Windows.Forms;
@@ -443,4 +444,5 @@
         IntValue intValue = value as IntValue;
         TimeSpanValue timeSpanValue = value as TimeSpanValue;
+        DateTimeValue dateTimeValue = value as DateTimeValue;
         double? ret = null;
         if (doubleValue != null) {
@@ -451,4 +453,6 @@
         else if (timeSpanValue != null) {
           ret = timeSpanValue.Value.TotalSeconds;
+        } else if (dateTimeValue != null) {
+          ret = dateTimeValue.Value.ToOADate();
         } else {
           int columnIndex = Matrix.ColumnNames.ToList().IndexOf(columnName);
@@ -531,9 +535,15 @@
       int axisDimensionCount = Enum.GetNames(typeof(AxisDimension)).Count();
       int columnIndex = xAxisComboBox.SelectedIndex - axisDimensionCount;
-      if (columnIndex >= 0 && Content.GetValue(0, columnIndex) is TimeSpanValue)
-        this.chart.ChartAreas[0].CursorX.Interval = 1;
+      if (columnIndex >= 0) {
+        var value = Content.GetValue(0, columnIndex);
+        if (value is TimeSpanValue || value is DateTimeValue)
+          this.chart.ChartAreas[0].CursorX.Interval = 1;
+      }
       columnIndex = yAxisComboBox.SelectedIndex - axisDimensionCount;
-      if (columnIndex >= 0 && Content.GetValue(0, columnIndex) is TimeSpanValue)
-        this.chart.ChartAreas[0].CursorY.Interval = 1;
+      if (columnIndex >= 0) {
+        var value = Content.GetValue(0, columnIndex);
+        if (value is TimeSpanValue || value is DateTimeValue)
+          this.chart.ChartAreas[0].CursorY.Interval = 1;
+      }
     }
 
@@ -734,4 +744,11 @@
           axis.CustomLabels.Add(i - axis.LabelStyle.Interval / 2, i + axis.LabelStyle.Interval / 2, x);
         }
+      } else if (dimension > 0 && Content.GetValue(0, dimension) is DateTimeValue) {
+        this.chart.ChartAreas[0].RecalculateAxesScale();
+        for (double i = axis.Minimum; i <= axis.Maximum; i += axis.LabelStyle.Interval) {
+          DateTime dt = DateTime.FromOADate(i);
+          string x = dt.ToString(CultureInfo.CurrentCulture);
+          axis.CustomLabels.Add(i - axis.LabelStyle.Interval / 2, i + axis.LabelStyle.Interval / 2, x);
+        }
       }
     }
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs	(revision 16892)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -265,4 +265,5 @@
       this.byTargetTabPage.TabIndex = 0;
       this.byTargetTabPage.Text = "Performance by Target";
+      this.byTargetTabPage.UseVisualStyleBackColor = false;
       // 
       // relativeOrAbsoluteComboBox
@@ -365,4 +366,5 @@
       this.byCostTabPage.TabIndex = 1;
       this.byCostTabPage.Text = "Performance by Cost";
+      this.byCostTabPage.UseVisualStyleBackColor = false;
       // 
       // byCostViewHost
@@ -415,4 +417,5 @@
       this.byTableTabPage.TabIndex = 2;
       this.byTableTabPage.Text = "Expected Runtime Tables";
+      this.byTableTabPage.UseVisualStyleBackColor = false;
       // 
       // ertTableView
